<?php

namespace Lc\ShopBundle\Form;

use Lc\ShopBundle\Context\ReductionCatalogInterface;
use Symfony\Component\Form\Extension\Core\Type\CheckboxType;
use Symfony\Component\Form\Extension\Core\Type\ChoiceType;
use Symfony\Component\Form\Extension\Core\Type\DateTimeType;
use Symfony\Component\Form\Extension\Core\Type\NumberType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Doctrine\ORM\EntityManagerInterface;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;


class ReductionCatalogType extends AbstractType
{
        protected $em;

        public function __construct(EntityManagerInterface $entityManager)
        {
                $this->em = $entityManager;
        }

        public function buildForm(FormBuilderInterface $builder, array $options)
        {
                $builder
                        ->add('title', TextType::class, ['label' => 'Titre'])
                        ->add('behaviorTaxRate', ChoiceType::class, [
                                'required'=> true,
                                'choices' => [
                                        'field.default.taxIncluded'=> 'tax-included',
                                        'field.default.taxExcluded'=> 'tax-excluded'
                                ]
                        ])
                        ->add('unit', ChoiceType::class, [
                                'required'=> true,
                                'choices' => [
                                        'field.default.percent'=> 'percent',
                                        'field.default.amount'=> 'amount'
                                ]
                        ])

                        ->add('value', NumberType::class, ['required' => true])
                        ->add('permanent', CheckboxType::class, ['required' => true])
                        ->add('dateStart', DateTimeType::class, ['widget' => 'single_text'])
                        ->add('dateEnd', DateTimeType::class, ['widget' => 'single_text']);
        }

        public function configureOptions(OptionsResolver $resolver)
        {
                $resolver->setDefaults([
                        'label' => false,
                        'data_class' => $this->em->getClassMetadata(ReductionCatalogInterface::class)->getName()
                ]);
        }
}
